
CoCoA - Bug #141

Memory leak using Elim in C5

30 Apr 2012 16:32 - John Abbott

Status: Closed Start date: 30 Apr 2012

Priority: Normal Due date:  

Assignee:  % Done: 100%

Category: Portability Estimated time: 4.00 hours

Target version:  Spent time: 0.20 hour

Description

The following code has the symptoms of a memory leak (grows to about 650Mbytes):

Use QQ[x,y,t];

Use ZZ/(32003)[x,y,t];

I := Ideal((8*t^3 -9*t^2 -4*t -8)*x -(6*t^3 -5*t^2 +7*t -7),

       (9*t^3 +8*t^2 -6*t +5)*y -(9*t^3 +8*t^2 -9*t +7));

For K := 1 To 10000 Do

  J := Elim([t],I);

EndFor;

 

I don't know if the leak is in C5 or in CoCoALib.

I expect that, once found, it will be almost trivial to fix.

BTW it could be handy to have BuildInfo in CoCoA-5 for those who report bugs.

Related issues:

Related to CoCoALib - Feature #142: Improve threadsafety In Progress 30 Apr 2012

History

#1 - 30 Apr 2012 17:44 - John Abbott

I was running a CoCoA-5 compiled with -DCoCoA_THREADSAFE_HACK.  The leaks I observed disappeared when I removed that compilation flag. 

No doubt the problem is due to the temporary rings (inside Elim) not self destroying when they're no longer needed -- ref counting is disabled when

the threadsafety hack is forced.

Maybe I should add a threadsafety issue?

#2 - 30 Apr 2012 17:52 - John Abbott

- Status changed from New to Closed

- % Done changed from 0 to 100

#3 - 13 Jul 2012 15:51 - Anna Maria Bigatti

- Category set to Portability
